CREATE TABLE "posts" (_id INTEGER PRIMARY KEY, cleaned_title TEXT COLLATE NOCASE, title TEXT, author TEXT, sortAuthors TEXT, interhash TEXT, intrahash TEXT, bibtexkey TEXT, bkey TEXT, misc TEXT, bibtexabstract TEXT, entrytype TEXT, address TEXT, annote TEXT, booktitle TEXT, chapter TEXT, crossref TEXT, edition TEXT, editor TEXT, howpublished TEXT, institution TEXT, organization TEXT, journal TEXT, note TEXT, number TEXT, pages TEXT, publisher TEXT, school TEXT, series TEXT, volume TEXT, day TEXT, month TEXT, cleaned_year INTEGER, year TEXT, type TEXT, url TEXT, privnote TEXT, content_type INTEGER, changeDate INTEGER, postingDate INTEGER, user TEXT, description TEXT, groups TEXT, tags TEXT, clipboard INTEGER);
CREATE TABLE "tas" (_id INTEGER PRIMARY KEY, posts_id INTEGER REFERENCES posts(_id) ON DELETE CASCADE, tag_name TEXT, tag_lower TEXT);
CREATE TABLE "gas" (_id INTEGER PRIMARY KEY, posts_id INTEGER REFERENCES posts(_id) ON DELETE CASCADE, group_name TEXT);
CREATE TABLE "tags" (_id INTEGER PRIMARY KEY, tag_name TEXT, tag_lower TEXT, user_count INTEGER);
CREATE TABLE "documents" (_id INTEGER PRIMARY KEY, intrahash TEXT, filename TEXT, content_hash TEXT);
CREATE INDEX posts_content_type_sort_author_idx ON "posts" (content_type, sortAuthors);
CREATE INDEX posts_content_type_title_idx ON "posts" (content_type, cleaned_title);
CREATE INDEX posts_content_type_postingDate_idx ON "posts" (content_type, postingDate);
CREATE INDEX posts_content_type_changeDate_idx ON "posts" (content_type, changeDate);
CREATE INDEX posts_content_type_year_idx ON "posts" (content_type, cleaned_year);
CREATE UNIQUE INDEX posts_intrahash_idx ON "posts" (intrahash);
CREATE INDEX gas_group_name_idx on "gas" (group_name);
CREATE INDEX gas_posts_id_idx ON "gas" (posts_id);
CREATE INDEX documents_intrahash_idx ON "documents" (intrahash);
CREATE INDEX tas_posts_id_idx ON "tas" (posts_id);
CREATE INDEX tas_tag_lower_idx ON "tas" (tag_lower);
CREATE INDEX tags_tag_lower_user_count_idx ON "tags" (tag_lower, user_count);